

<template>
    <main class="main__chat">
        <div class="chat__container">
            <div class="chat">
                <div class="chat__top">
                    <div class="chat__avatar">
                        <img src="../img/images/logo-chat.png" alt="avatar">
                    </div>
                    <div class="chat__name">
                        Chat with a Travelcom manager
                    </div>
                </div>
                <div class="chat__messages">

                    <template v-for="message in messages">

                        <div class="message message__my" v-if="userId === message.user_id">
                            <div class="message__time">
                                {{convertDate(message.created_at)}}
                            </div>
                            <div class="message__text" style="white-space: pre-wrap;">
                              <template v-if="message.text.indexOf('<img') <= 0">
                                <span v-html="message.text"></span>
                              </template>
                              <template v-else>
                                {{message.text}}
                              </template>

                            </div>
                        </div>
                        <div class="message" v-else>
                            <div class="message__text">
                              <template v-if="message.text.indexOf('<img') <= 0">
                                <span v-html="message.text"></span>
                              </template>
                              <template v-else>
                                {{message.text}}
                              </template>
                            </div>
                            <div class="message__time">
                                {{convertDate(message.created_at)}}
                            </div>
                        </div>
                    </template>

                </div>
                <div class="chat__write">
                    <div class="chat__write--message">
                        <textarea name="chat" v-model="message"></textarea>
                        <form method="post" enctype="multipart/form-data">
                            <div class="input-file-row">
                                <label class="input-file">
                                    <input type="file" @change="uploadImage" name="file[]" multiple>
                                    <span><img src="../img/icons/paperclip.svg" alt="paperclip"></span>
                                </label>
                                <div class="input-file-list"></div>
                            </div>
                        </form>
                    </div>
                    <div class="chat__write--send">
                        <button @click="sendMessage">
                            <img src="../img/icons/chat-send.svg" alt="send">
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
import axios from "../axios/index.js";

export default {
    name: "Chat",
    data() {
        return {
            message: '',
            messages: [],
            userId: JSON.parse(localStorage.user).id
        }
    },
    mounted() {
        this.getMessage()

        Pusher.logToConsole = true;

        var pusher = new Pusher('9e6dd00ba6c994e5ebfe', {
            cluster: 'eu'
        });

        let self = this

        var channel = pusher.subscribe('chat_' + this.userId);
        channel.bind('new-message', function(data) {
            self.messages.push(data);
        });

    },
    methods: {
      uploadImage(e) {
        let img = e.target.files[0]
        let fd= new FormData()
        fd.append('image', img)
        axios.post('/api/chat/send_message', fd)
            .then(resp => {
              this.imagePath = resp.data.path
            })
      },
        sendMessage() {
            axios.post('/api/chat/send_message', {
                message: this.message
            }).then(({data}) => {
                this.message = ''
            })
        },
        convertDate(date) {
            let date2 = new Date(date)
            return date2.getHours() + ":" + date2.getMinutes()
        },
        getMessage() {
            axios.get('/api/chat/get_messages').then(({data}) => {
                this.messages = data.messages
            })
        }
    }
}
</script>

<style scoped>

</style>
